/*
 * ddfs_store.h
 *
 *  Created on: 29 Oct 2010
 *      Author: ngchunho
 */

#ifndef DDFS_STORE_H_
#define DDFS_STORE_H_
#include <linux/module.h>
#include <linux/string.h>
#include <linux/fs.h>
#include <linux/time.h>
#include <linux/jbd.h>
#include "ext3_fs.h"
#include "ext3_jbd.h"
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/blkdev.h>
#include <linux/smp_lock.h>
#include <linux/buffer_head.h>
#include <linux/exportfs.h>
#include <linux/vfs.h>
#include <linux/random.h>
#include <linux/mount.h>
#include <linux/namei.h>

int ddfs_hash_compute(char * dst, char * src, int len);

int ddfs_count_read(struct super_block * sb, __u32 blk_no, __u32 * count);
int ddfs_count_write(handle_t * handle, struct super_block * sb, __u32 blk_no, __u32 count);
int ddfs_count_write_delta(handle_t * handle, struct super_block * sb, __u32 blk_no, __s32 delta,__u32 * rest_link_count);

int ddfs_hash_read(struct super_block * sb, __u32 blk_no, __u8 hash[DDFS_HASH_LEN]);
int ddfs_hash_write(handle_t * handle, struct super_block * sb, __u32 blk_no, __u8 hash[DDFS_HASH_LEN]);
int ldfs_store_search(struct super_block * sb, __u8 hash[DDFS_HASH_LEN], __u32 storenr, __u32 * blocknr);

#endif /* DDFS_STORE_H_ */
